/*  INF3105 - Structures de données et algorithmes
    UQAM | Faculté des sciences | Département d'informatique
    © Jaël Champagne Gareau (champagne_gareau.jael@uqam.ca)
 */
#include <algorithm>
#include <iostream>
#include <random>

#include "monceau.h"

using namespace std;

bool test(int n) {
  cout << "test(n=" << n << ");" << endl;
  int* tab = new int[n];
  Monceau<int> m;

  std::random_device rd;
  std::mt19937 gen(rd());
  std::uniform_int_distribution<> distrib(0, n);

  for (int i = 0; i < n; i++) {
    tab[i] = distrib(gen);
    m.inserer(tab[i]);
  }

  sort(tab, tab + n);
  bool ok = true;
  for (int i = 0; i < n; i++) {
    int suivant = m.minimum();
    m.enleverMinimum();
    if (suivant != tab[i]) {
      cout << "Le monceau ne fonctionne pas correctement: " << suivant
           << "!=" << tab[i] << " !" << endl;
      ok = false;
    }
  }
  delete[] tab;
  return ok;
}

int main() {
  for (int n = 10; n < 10000; n += 25)
    if (!test(n)) return EXIT_FAILURE;

  cout << "Le monceau fonctionne correctement !" << endl;
  return EXIT_SUCCESS;
}
